; battle2.asm
;  battle routines

; read keypresses


exitShowBattleChars2:

 ;*****************
 ;* VICTORY
 ;*****************

 ; check for enemy victory

 ld hl,battleQueue
checkEnemyVictory:
 ; at end of queue?
 ld a,(hl)
 or a
 jp z,enemyBattleVictory

 ; are we looking at party members only?
 inc hl
 ld a,(hl)
 cp 4
 jr nc,skipCheckEnemyVictory

 ; are they al dead?
 dec hl
 ld a,(hl)
 inc hl
 cp 1
 jr nz,noEnemyVictory

skipCheckEnemyVictory:
 ld de,15
 add hl,de
 jr checkEnemyVictory

noEnemyVictory:

 ld hl,battleQueue
checkPartyVictory:
 ; at end of queue?
 ld a,(hl)
 or a
 jp z,partyBattleVictory

 ; are we looking at enemies only?
 inc hl
 ld a,(hl)
 cp 4
 jr c,skipCheckPartyVictory

 ; are they al dead?
 dec hl
 ld a,(hl)
 inc hl
 cp 1
 jr nz,noPartyVictory

skipCheckPartyVictory:
 ld de,15
 add hl,de
 jr checkPartyVictory

noPartyVictory:

 ; is a character ready to attack?

 ld a,(charsReadyToAttack)
 or a
 jr z,readKeysBattle

 ; display cursor at that character
 dec a

 ; determine where the ready to attack character is.
 ld hl,battleQueue
 sla a
 sla a
 sla a
 sla a
 ld e,a
 ld d,0
 add hl,de

 inc hl
 inc hl

 ; xpos of party member
 ld c,(hl)
 srl c
 srl c
 srl c
 inc hl
 ld a,(hl)
 ld l,a
 add a,a
 add a,l
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 ld b,0
 add hl,bc

 dec hl				; bring it 1 spot in front of the party member
 ld de,plotsscreen+60
 add hl,de

 ex de,hl
 ld hl,animCursor
 call align6			; display cursor in front of attacker

 ; show battle action menu
 ;  FIGHT
 ;  TECH
 ;  MAGIC
 ;  ITEM
 call showBattleMenu

 ; show the cursor (was setup in partyMemberAttack)

 call displayCursor
 
readKeysBattle:
 ld a,(itemSelect)
 cp 0FFh
 jp nz,battleItemMenu


 ; is there anyone attacking
 ;  if so show the damage on their victim
 ld hl,battleQueue
whoIsAttacking:
 ld a,(hl)
 cp 5
 jr nc,showDamageToVictim
 inc hl
 ld a,(hl)
 or a
 jr z,noAttackReadKeys

 ld de,15
 add hl,de
 jr whoIsAttacking

showDamageToVictim:
 ; show the damage on your victim

 ld b,(hl)
 srl b
 ld a,(attackQueue+4)
 add a,5
 ld (pencol),a

 ld a,(attackQueue+5)
 add a,b
 ld (penrow),a

 ld hl,fightDamage
 call showHL


noAttackReadKeys:

 B_CALL GrBufCpy

 ei
 halt
 halt
 halt
 halt
 halt

 B_CALL getcsc
 cp sk2nd
 jp z,battlePress2nd

 cp skUp
 jr z,battleCursorUp
 cp skDown
 jr z,battleCursorDown
 cp skMode
 jp nz,drawBattleLoop
 ret

battleCursorDown:
 ld a,(cursorPos)
 cp 3
 jp z,drawBattleLoop
 inc a
 ld (cursorPos),a
 jp drawBattleLoop

battleCursorUp:
 ld a,(cursorPos)
 or a
 jp z,drawBattleLoop
 dec a
 ld (cursorPos),a
 jp drawBattleLoop

;------------------
; 222        d
;    2       d
;   2  nn   dd
;  2   n n d d
; 2222 n n  dd
;------------------
battlePress2nd:
 ; have we chosen an action?
 ld a,(actionSelect)
 or a
 jp z,drawBattleLoop

 ; is a party member ready to attack
 ld a,(charsReadyToAttack)
 or a
 jp z,drawBattleLoop

 ; find that party member
 ld b,a
 ld hl,battleQueue+1
 call findVictimChar

 ; did you FIGHT or ITEM

 ld a,(cursorPos)
 or a
 jr z,FIGHTselected
 cp 3
 jp z,ITEMselected

FIGHTselected:
 ; set him to wait until attack
 ld a,4
 ld (hl),a

 ; ADD AN ATTACK

 ; get to end of attack queue
 push bc
  ld de,8
  ld hl,attackQueue
  call getLastEntryOfAttackQ
 pop bc

 ; set the attacker
 ld (hl),b									; CHAR PERFORMING ACTION

 ; attack the first enemy on the list.
 ld (victimChar),hl						; preserve HL = attackQ[i]

 ld hl,battleQueue
findEnemyForPartyToAttack:
 ld a,(hl)
 cp 1
 jr z,checkNextEnemyToAttack		; dead guy

 inc hl
 ld a,(hl)

 dec hl
 cp 4
 jr nc,foundAnEnemyToAttack

checkNextEnemyToAttack:
 ld de,16
 add hl,de
 jr findEnemyForPartyToAttack

foundAnEnemyToAttack:
 ; found an enemy
 inc hl
 ex de,hl
 ld hl,(victimChar)
 inc hl
 ld (hl),a									; VICTIM CHAR TYPE

 push af
 ; action type
 inc hl
 xor a										; FIGHT
 ld (hl),a

 ; prepare to load in victim's coordinates
 inc hl
 inc hl
 inc hl
 ; get to victim's coordinates
 ld a,(de)
 ld (hl),a
 inc de
 inc hl
 ld a,(de)
 ld (hl),a
 pop af

 ; damage to enemy
 
 push hl
  call findBattleChar
  ld de,13
  add hl,de
  ld b,(hl)

  push bc
 ;  ld a,(currentCharacter)
   ld a,(charsReadyToAttack)
   call findBattleChar
   ld de,12
   add hl,de
   ld a,(hl)
  pop bc

  call findHPlost
  ex de,hl
 pop hl

 ld (hl),e
 inc hl
 ld (hl),d

 inc hl
 xor a
 ld (hl),a

 call updateCharsReadyToAttack

 ; reset the action select
 ld (actionSelect),a
 jp drawBattleLoop

updateCharsReadyToAttack:
  ; update chars ready to attack queue
 ld a,(charsReadyToAttack+1)
 ld (charsReadyToAttack),a
 ld a,(charsReadyToAttack+2)
 ld (charsReadyToAttack+1),a
 xor a
 ld (charsReadyToAttack+2),a
 ret



 ; show battle action menu
 ;   and blacken the screen there
 ;  FIGHT
 ;  TECH
 ;  MAGIC
 ;  ITEM
showBattleMenu:
 ld hl,plotsscreen+481

 ld b,24
boxBattleOps2:
 ld (hl),255
 inc hl
 ld (hl),255
 inc hl
 ld (hl),11111000b
 ld de,10
 add hl,de
 djnz boxBattleOps2

 set textInverse, (iy+textflags) ; sets inverse.

 ld hl,256*40+10
 ld (pencol),hl
 ld hl,battleText0
 call vputsApp

 ld hl,256*46+10
 ld (pencol),hl
 ld hl,battleText1
 call vputsApp

 ld hl,256*52+10
 ld (pencol),hl
 ld hl,battleText2
 call vputsApp

 ld hl,256*58+10
 ld (pencol),hl
 ld hl,battleText3
 call vputsApp

 res textInverse, (iy+textflags) ; resets inverse.
 ret
