; new battle engine
;   work began on 2/7/02

; battleQueue
;  16 bytes per entry

;0 .db <char state>		; 1=dead, 2=normal, 3=ready, 4=wait, 5-14=attack
;1 .db <char ID>			; for sprites
;2 .db <x position>
;3 .db <y position>
;4 .db <gauge position> ; position of gauge
;5 .db <gauge speed>		; *
;6,7 .dw <HP>
;8,9 .dw <max HP>
;10 .db <MP>				; *
;11 .db <mp max>			; *
;12 .db <AP>				; attack
;13 .db <DP>				; defense
;14 .db <hit%>				; *
;15 .db <evade%>			; *

victimHPlost .equ saveSScreen+14
partyMembers .equ saveSScreen+16
time .equ partyMembers+1
currentCharacter .equ time+1
currentCharPointer .equ currentCharacter+1	; 2 bytes
currentCharNumber .equ currentCharPointer+2
victimCharPointer .equ currentCharNumber+1	; 2 bytes
charsReadyToAttack .equ victimCharPointer+2 ; 3 bytes
actionSelect .equ charsReadyToAttack+3
victimChar .equ actionSelect+1

battleQueue .equ saveSScreen+32
attackQueue .equ saveSScreen+160

battle2:
 ; setup stuff

 ld a,0FFh
 ld (itemSelect),a

 xor a
 ld (charsReadyToAttack),a

 call loadBattle2

 ; if party member is dead, show them as dead

 ld hl,battleQueue

bringOutYourDead:
 ld a,(hl)
 or a
 jr z,drawBattleLoop

 ld de,6
 add hl,de

 ld a,(hl)
 or a
 jr nz,imNotDeadYet

 inc hl
 ld a,(hl)
 or a
 jr nz,imNotDeadYet2

 ; dead guy... get back to state
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 ld (hl),1

 ld de,6
 add hl,de

imNotDeadYet:
 inc hl
imNotDeadYet2:
 ld de,9
 add hl,de
 jr bringOutYourDead

drawBattleLoop:
 B_CALL GrBufClr
 ld a,(time)
 inc a
 ld (time),a

 ; show other stuff, then the characters

 ;*********
 ;* GAUGE *
 ;*********

 ; show the outline on the ready gauge for each party member
 ; inside of gauge is 16x3

 ; CHAR 1 GAUGE
 ld hl,plotSScreen+573
 call showGaugeOutline

 ; CHAR 1 NAME
 ld hl,256*46+40
 ld (pencol),hl
 ld hl,char1
 call vputsApp

 ld a,(partyMembers)
 cp 2
 jr c,incompletePartyForBattle

 ; CHAR 2 GAUGE
 ld hl,plotSScreen+645
 call showGaugeOutline

 ; CHAR 2 NAME
 ld hl,256*52+40
 ld (pencol),hl
 ld hl,char2
 call vputsApp

 ld a,(partyMembers)
 cp 3
 jr c,incompletePartyForBattle

 ; CHAR 3 GAUGE
 ld hl,plotSScreen+717
 call showGaugeOutline

 ; CHAR 3 NAME
 ld hl,256*58+40
 ld (pencol),hl
 ld hl,char3
 call vputsApp

 ;************
 ;* FIGHTERS *
 ;************

incompletePartyForBattle:
 ; show the characters and enemies
 xor a
 ld (currentCharNumber),a
 ld hl,battleQueue

showBattleChars2:
 ld (currentCharPointer),hl

 ld a,(hl)
 or a
 jp z,exitShowBattleChars2

 inc hl
 push af
  ld a,(hl)
  ld (currentCharacter),a
 pop af

 ;***************
 ; STATES
 ;***************

 cp 1
 jp z,deadBattleState
 cp 2
 jp z,normalBattleState
 cp 3
 jp z,readyBattleState
 cp 4
 jp z,waitBattleState

 ; attack battle state
 ;   show for 10 ticks

 cp 15
 jp z,finishAttackState

;-------------------------
; 555 | Battle States 5-14
; 5   |-------------------
; 55	|attackBattleState
;   5 | 
; 55	|info:
;------
;  shows you attacking
;    with weapon
;-------------------------

attackBattleState:
 dec hl
 inc (hl)					; go to next attack state (5-14)
 
 ld bc,0

 ; is it an enemy?
 ld a,(currentCharacter)
 cp 4
 jr nc,attackShowChar

 ; what type of Action?
 ld a,(attackQueue+2)
 cp 1
 jr z,attackFIGHT

; draw the item animation!


attackFIGHT:
 ; draw the attack

 ld hl,weaponSprites-8
 ld a,(attackQueue)
 add a,a
 add a,a
 add a,a
 ld c,a
 ld b,0
 add hl,bc

 push hl
  ld hl,(currentCharPointer)
  inc hl
  inc hl
  ld a,(hl)
  sub 32
  inc hl
  ld e,(hl)
 pop hl
 call sprite8

 ld bc,96
attackShowChar:
 ; show the character
 ld hl,(currentCharPointer)
 inc hl
 inc hl
 push bc
 call getCharSprite
 pop bc
 push hl
  ex de,hl
  add hl,bc
  ex de,hl
 pop hl

 ld a,(currentCharacter)
 cp 4
 jr nc,attackMoveRight3

 dec hl
 dec hl
 dec hl
 jr attackMove

attackMoveRight3:
 inc hl

attackMove:
 call showBattleSprite
 jp showBattleGauge 


;------------------------
;  11   | Battle State 1
;   1   |----------------
;   1   | deadBattleState
;   1   |
; 11111 | info:
;-------
; character is dead.
;  cleans up all other
;  attack information 
;  about that char
;------------------------- 
deadBattleState:
 ; show dead pic

 ld a,(currentCharacter)
 cp 4
 jr nc,dontShowDeadEnemy

 dec a

 add a,a
 add a,a
 add a,a
 add a,a
 add a,a
 ld e,a
 ld d,0
 ld hl,deadSprites
 add hl,de
 ex de,hl
 push de
  ld hl,(currentCharPointer)
  inc hl
  inc hl
  call getCharSprite
  ld (itemSelection),hl
 pop de
 call showBattleSprite

dontShowDeadEnemy:
 ld hl,(currentCharPointer)
 inc hl
 ld b,(hl)
 ld a,(attackQueue)
 cp b
 jr nz,deadGuysAttackNotReady

 ; update attack queue

 ld de,attackQueue
 ld hl,attackQueue+8
 ld bc,40					; 5 attacks
 ldir

deadGuysAttackNotReady:
 ld hl,currentCharNumber
 inc (hl)
 ld hl,(currentCharPointer)
 inc hl
 ld a,(hl)
 cp 4
 jr nc,dontResetDeadCharAwaitQueue

 ld b,a
 ld a,(charsReadyToAttack)
 cp b
 jr nz,showDeadPartyMember

 call updateCharsReadyToAttack
showDeadPartyMember:
 ; show sprite for dead party member

 ld hl,currentCharNumber
 dec (hl)
   ; show that they have 0 hit points
 jp showHitPoints

dontResetDeadCharAwaitQueue:
 ld hl,(currentCharPointer)
 ld de,16
 add hl,de
 jp showBattleChars2


;------------------------
; 333   | Battle State 3
;    3  |----------------
;  33   | waitBattleState
;    3  |
; 333   | info:
;-------
; waits until your attack
;  appears first in the
;  attack queue.
; makes sure you dont
;  attack dead guys
;------------------------- 
waitBattleState:
 ; nothing now.
 ;   need to read the attackQ since we have an attack waiting.

 ld b,(hl)						; current character
 ld a,(attackQueue)
 cp b
 jp nz,normalBattleState	; not 1st on list to attack

 ;---------------------
 ; process attack queue
 ;---------------------

 ; never let enemies or party members attack dead guys
 call setVictimPointer
 ld a,(hl)
 cp 1
 jp nz,notAttackingDeadChar

 ; serious problem.
   ; must choose a new person to be attacked

 ld hl,battleQueue

 ld a,(attackQueue)
 cp 4
 jr c,partyMemberAttackingTheDead

 ; enemy is attacking the dead
findNewVictim1:
  ld a,(hl)
  or a
  jr z,notAttackingDeadChar
  
  inc hl

  cp 1
  jr z,skipFindNewVictim1

  ld a,(hl)
  cp 4
  jr c,newVictimFound
  jr notAttackingDeadChar

skipFindNewVictim1:
  ld de,16
  add hl,de
  jr findNewVictim1

partyMemberAttackingTheDead:
findNewVictim2:
  ld a,(hl)
  or a
  jr z,notAttackingDeadChar
  inc hl
  
  cp 1
  jr z,skipFindNewVictim2

  ld a,(hl)
  cp 4
  jr nc,newVictimFound
  jr notAttackingDeadChar

skipFindNewVictim2:
  ld de,16
  add hl,de
  jr findNewVictim2

newVictimFound:
 ld (attackQueue+1),a
 inc hl
 ld a,(hl)
 ld (attackQueue+5),a
 inc hl
 ld a,(hl)
 ld (attackQueue+6),a

 ; RECALCULATE DAMAGE!!!

notAttackingDeadChar:
 ; show attacker graphics
 ld hl,(currentCharPointer)
 ld a,5
 ld (hl),a
 inc hl
 jp normalBattleState

readyBattleState:
 push hl
  call addAttack2
 pop hl
 inc hl
 jp drawTheCharacterBattle


;------------------------
; 1 555 | Battle State 15
; 1 5   |----------------
; 1 55  |finishBattleState
; 1   5 | 
; 1 55  |info:
;--------
;  process attack
;    reset character
;-------------------------
finishAttackState:

 ld a,(attackQueue+2)
 or a
 jr z,finishFightState

 cp 3
 jr nz,finishFightState

 call finishItemState

 jp didNotFindVP


finishFightState:
; inflict damage
 call setVictimPointer
 ld de,6
 add hl,de
 ; get hl from hl
 ld e,(hl)
 inc hl
 ld d,(hl)
 push hl
  ld hl,(fightDamage)
  ex de,hl
  xor a
  sbc hl,de
  jr nc,victimNotDead

 pop hl
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 dec hl
 ld a,1
 ld (hl),a

 ld de,7
 add hl,de
 push hl
  ld hl,0
victimNotDead:
  ex de,hl
 pop hl
 ld (hl),d
 dec hl
 ld (hl),e

didNotFindVP:
 ; change state to normal
 ld hl,(currentCharPointer)
 ld a,2
 ld (hl),a

 ; reset gauge
 inc hl
 inc hl
 inc hl
 inc hl
 xor a
 ld (hl),a

 ; remove first attack from queue

 ld de,attackQueue
 ld hl,attackQueue+8
 ld bc,40					; 5 attacks
 ldir

 ld hl,(currentCharPointer)
 inc hl

normalBattleState:
 inc hl

drawTheCharacterBattle:

 call getCharSprite
 call showBattleSprite

showBattleGauge:
 ; ****************
 ;  GAUGE
 ; ****************

 ld hl,(currentCharPointer)
 ld a,(hl)
 inc hl
 inc hl
 inc hl
 inc hl
 cp 2
 jr nz,doNotUpdateGauge

 ; show their gauges


 inc hl
 ld b,(hl)
 dec hl
 ld a,(hl)
 add a,b
 call c,charAwaitsAction

 ld (hl),a
; call debug1235
doNotUpdateGauge:

 ; get Y position of gauge
 ;   48 + a*6

 ld a,(currentCharacter)
 cp 4
 jr nc,skipDispGauge2		; it is an enemy

 dec a
 ld b,a
 add a,a
 add a,b
 add a,a

 add a,48
 ld c,a
 
 ; get length of gauge

 ld a,(hl)
 srl a
 srl a
 srl a
 srl a
 
 inc a
 ld b,a

 ld a,79
dispGaugeLoop2:
 push bc
 push af
 ld e,c
 call bar_sprite
 pop af
 inc a
 pop bc
 djnz dispGaugeLoop2

skipDispGauge2:

showHitPoints:
 ld a,(currentCharacter)
 dec a

 ; show hit points
 ld b,a
 add a,a
 add a,b
 add a,a
 add a,46
 ld (penrow),a

 ld a,60
 ld (pencol),a

 ld hl,(currentCharPointer)
 ld de,6
 add hl,de
 call showHL

skipShowHP2:
 ld a,(currentCharNumber)
 inc a
 ld (currentCharNumber),a

 ld hl,(currentCharPointer)
 ld de,16
 add hl,de
 jp showBattleChars2				; GO THROUGH THE MAIN LOOP AGAIN