; terry peng gave me this idea a long time ago.
;  a long time ago being 1998, when i started zelda 83

collide_up:
; call dmapSub
 call getYourPosition
 call collide_detect
 ret c
collide_vert:
 push hl
 ld a,(x)
 call divby12
 ld a,h
 pop hl
 or a
 ret z			; aligned?
 inc hl
 ;call dmapSub
 call collide_detect
 ret

collide_down:
 ld a,(y)
 add a,10
 ld (y),a
 jr collide_up

collide_left:
 call getYourPosition
 call collide_detect
 ret c
collide_horiz:
 push hl
 ld a,(y)
 dec a
 dec a
 call divby12
 ld a,h
 pop hl
 or a
 ret z			; aligned?

 call addNextColumn
 call collide_detect
 ret

collide_right:
 ld a,(x)
 add a,10
 ld (x),a
 jr collide_left

collide_detect:
 ld a,(hl)
 cp 040h
 jp z,mapActionTREASURE
 cp 9
 jr z,mapActionDOOR
 cp 03Fh
 jr z,mapActionDOOR
 cp 03Eh
 jr z,mapActionDOOR
 cp 03Ch
 jr z,mapActionDOOR
 cp 042h
 jr z,mapActionDOOR
 cp 044h
 jr z,mapActionDOOR
 cp 045h
 jr z,mapActionDOOR
 cp 16
 jp z,mapActionNPC
 cp 047h
 jp z,mapActionNPC
 cp 17
 jr z,mapActionDOOR
 cp 4
 jr c,no_collision

 scf
 ret

no_collision:
 xor a
 ret


mapActionDOOR:

 ld ix,switchMapTable
scanSwitchMapTable:
 ld a,(ix)
 ld e,a
 inc ix
 ld d,(ix)
 ld a,e
 or d
 or a
 jp z,noMapMatch
 inc ix
 push hl
 push de
  call loadAppvarInDE
  ex de,hl
 pop de
  add hl,de
  ex de,hl
 pop hl



 B_CALL cphlde
 jr z,switchMapMatch

 inc ix
 inc ix
 inc ix

 inc ix
 inc ix
 inc ix
 inc ix
 inc ix
 inc ix
 jr scanSwitchMapTable

switchMapMatch:
 ld e,(ix)
 ld d,(ix+1)
 ld a,(ix+2)
 ld (mapX),a
 ld a,(ix+3)
 ld (mapY),a
 ld a,(ix+4)
 ld (charX),a
 ld a,(ix+5)
 ld (charY),a
 ld a,(ix+6)
 ld (mapWidth),a
 ld a,(ix+7)
 ld (mapHeight),a
 ld a,(ix+8)
 ld (mapID),a

 ex de,hl
 push hl
  call loadAppvarInDE
 pop hl
 add hl,de
 ld (mapStart),hl

 ; show the name of the new map
 ld a,(mapID)
 or a
 jr z,noMapMatch

 dec a
 add a,a
 ld e,a
 ld d,0
 ld hl,mapTitles
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 call showDialog

noMapMatch:
 scf
 ret

mapActionNPC:
 ld ix,dialogTable
scanDialogTable:

 ld a,(ix)
 or a
 jr z,noMapMatch
 ld e,a

 inc ix
 ld d,(ix)
 inc ix
 push hl
 push de
  call loadAppvarInDE
  ex de,hl
 pop de
  add hl,de
  ex de,hl
 pop hl
 B_CALL cphlde
 jr z,dialogMatch

 inc ix
 inc ix
 jr scanDialogTable

dialogMatch:
 ld e,(ix)
 inc ix
 ld d,(ix)
 ex de,hl
 call showDialog
 B_CALL getkey
 scf
 ret

mapActionTREASURE:


 ld ix,treasureTable
scanTreasureTable:
 ld a,(ix)
 or a
 jr z,noMapMatch
 ld e,a

 inc ix
 ld d,(ix)
 push hl
 push de
  call loadAppvarInDE
  ex de,hl
 pop de
  add hl,de
  ex de,hl
 pop hl

 B_CALL cphlde
 jr z,treasureMatch

 inc ix
 inc ix
 inc ix
 jr scanTreasureTable

treasureMatch:
 ; opened treasure chest
 ld (hl),046h

 ld hl,plotsscreen
 ld (hl),0
 ld de,plotsscreen+1
 ld bc,127
 ldir

 inc ix
 ld b,(ix)
 inc ix
 ld c,(ix)
 call addItem

 dec hl
 dec hl
 ld (itemPointer),hl
 xor a
 call displayItem
 B_CALL grbufcpy
 B_CALL getkey
 scf
 ret



getYourPosition:
 call adjustMap
 push hl
  call mapPosDE
 pop hl
 add hl,de
 ret

addNextColumn:
 ld a,(mapWidth)
 ld e,a
 ld d,0
 add hl,de
 ret

; UTILITY

mapPosDE:
 ld de,0

 ld a,(y)
 dec a
 dec a					; offset by 2
 ; divide by 12
 push de
  call divby12
 pop de
 or a
 jr z,skipMapPosDE

  ; multiply it by (# columns)
 ld b,a

 ld a,(mapWidth)
 ld e,a
 ld d,0
 ld hl,0
mapPosDELoop:
 add hl,de
 djnz mapPosDELoop

 ex de,hl

skipMapPosDE:
 push de
  ld a,(x)
  ; divide it by 12
  call divby12
  ld d,0
  ex de,hl
 pop de
 add hl,de
 ex de,hl
 ret


tableDebug:
 push hl
  xor a
  ld (curcol),a
  ld (currow),a
  push de
  B_CALL disphl
  pop de
  ex de,hl
  B_CALL disphl
  push de
  B_CALL getkey
  pop de
 pop hl
 ret


