dialogPointer .equ appBackUpScreen+60

; input: HL = dialog location
; output: text on screen

showDialog:
 ld (dialogPointer),hl 
 call popupMessageBox

 ld hl,0
 ld (pencol),hl

 set textInverse, (iy+textflags) ; sets inverse.
redrawDialog:
 call blackMessageBox
 
showDialogLoop:
 ld hl,(dialogPointer)
 ld a,1
 ld (pencol),a
 call printUntil
 inc hl
 ld (dialogPointer),hl
 push af
  ld a,(penrow)
  add a,6
  ld (penrow),a
  B_CALL grbufcpy
 pop af
 or a
 jr z,quitDialog
 cp 1
 jr z,showDialogLoop
 cp 2
 jr z,waitDialog
 cp 3
 jr z,endScreenDialog

 jr showDialogLoop

waitDialog:
 ld b,100
 call delayDialog
 jr showDialogLoop

delayDialog:
 ei
dialogDelay:
 halt
 djnz dialogDelay
 ret

endScreenDialog:
 xor a
 ld (penrow),a
 ld b,0
 call delayDialog
 jr redrawDialog

quitDialog:
 call pauseDialog
 res textInverse, (iy+textflags) ; resets inverse.
 ret

pauseDialog:
 ei
 halt

 B_CALL getcsc
 or a
 jr z,pauseDialog
 ret

printUntil:
 ld a,(hl)
 cp 6
 ret c
 inc hl
 push hl
 B_CALL VPutMap
 pop hl
 jr printUntil

popupMessageBox:

 ld c,12
pmbOuter:
 push bc
; B_CALL grbufclr
 ld hl,plotsscreen
 pop bc

 ld a,13
 sub c
 ld b,a 
pmbInner:
 push bc
  ld a,12
  sub c
  inc a
  ld b,a
pmbInner2:
  ld (hl),255
  inc hl
  djnz pmbInner2
 pop bc
 ld e,c
 dec e
 ld d,0
 add hl,de
 djnz pmbInner

 push bc
  B_CALL grbufcpy

  ei
  ld b,10
pmbDelay:
  halt
  djnz pmbDelay
 pop bc

 dec c
 jr nz,pmbOuter
 ret

blackMessageBox:
 ld hl,plotsscreen
 ld de,plotsscreen+1
 ld (hl),255
 ld bc,155
 ldir
 ret

dialogTable:
 dw innMap+1+40,inn_dialog1
 dw castleMap+84+10,castle_dialog1
 dw 0

; how this works...
; 0 = end
; 2 = delay 1 sec
; 3 = delay 3 sec, new screen
inn_dialog1:
 db "Innkeeper: If I was you",2
 db "I would search for a cave",0

castle_dialog1:
 db "Guard: HAIL ELAN!",2
 db "Hawk and Snake: HAIL",3
 db "Guard: I am sorry",2
 db "but DIRK may not enter",0

