mapID .equ saveSScreen
mapStart .equ mapID+1
x .equ mapStart+2
y .equ x+1
mapX .equ y+1
mapY .equ mapX+1
charX .equ mapY+1
charY .equ charX+1
charDir .equ charY+1
charTimer .equ charDir+1
charMovingSprite .equ charTimer+1
mapWidth .equ charMovingSprite+1
mapHeight .equ mapWidth+1
tempSPRITE .equ mapHeight+1
drawmapCounter .equ tempSPRITE+1
keyHeld .equ drawmapCounter+1
night .equ keyHeld+1

setupOverworld:
 xor a
 ld (night),a

 ld a,2
 ld (keyHeld),a
 ld (charTimer),a

moveLoop:
 ; is it outside in overworld
 ld a,(mapID)
 cp 1
 jr z,moveLoop2
 cp 4
 jr z,moveLoop2
 cp 5
 jr z,moveLoop2

 ; RANDOM BATTLE?

 call getrand
 cp 43
 call z,battle2

 xor a
 ld (night),a

moveLoop2:
 ld hl,charTimer
 inc (hl)

 B_CALL GrBufClr

 call drawmap
 ld a,(night)
 or a
 call nz,nightTime

 call showCharacter
 B_CALL GrBufCpy

 ei
 halt
 halt

 B_CALL GetCSC

 cp skLeft
 jr z,moveCharLeft
 cp skRight
 jr z,moveCharRight
 cp skUp
 jp z,moveCharUp
 cp skDown
 jp z,moveCharDown

 cp skAlpha
 jp z,setupMenuScreen

 cp skEnter
 jp z,debugMap

 cp skMode
 jr z,gotoMenuScreen

 cp skClear
 jr nz,moveLoop2
 jp exit

gotoMenuScreen:
 call setupMenuScreen
 jp moveLoop2

moveCharLeft:
 xor a
 ld (charDir),a
 ld a,(charX)
 or a
 jp z,moveLoop
 dec a
 dec a

 ld (x),a
 ld (temp),a
 call collide_left
 jp c,moveLoop
 ld a,(temp)

 cp 14
 jr c,scrollMapLeft

 ld (charX),a
 jp moveLoop

scrollMapLeft:
 ld a,(mapX)
 or a
 jr z,finishMoveCharLeft
 dec a
 ld (mapX),a
 ld a,(charX)
 add a,10
 ld (charX),a
 jp moveLoop

finishMoveCharLeft:
 ld a,(charX)
 or a
 jp z,moveLoop
 dec a
 dec a
 ld (charX),a
 jp moveLoop

moveCharRight:
 ld a,2
 ld (charDir),a
 ld a,(charX)
 inc a
 inc a

 ld (x),a
 ld (temp),a
 call collide_right
 jp c,moveLoop
 ld a,(temp)

 cp 72
 jr nc,scrollMapRight

 ld (charX),a
 jp moveLoop

scrollMapRight:
 ld a,(mapWidth)
 sub 8
 ld b,a
 ld a,(mapX)
 cp b
 jp z,finishMoveCharRight

 inc a
 ld (mapX),a
 ld a,(charX)
 sub 10
 ld (charX),a
 jp moveLoop

finishMoveCharRight:
 ld a,(charX)
 cp 84
 jp z,moveLoop
 inc a
 inc a
 ld (charX),a
 jp moveLoop

moveCharUp:
 ld a,1
 ld (charDir),a
 ld a,(charY)
 cp 2
 jp z,moveLoop

 dec a
 dec a

 ld (y),a
 ld (temp),a
 call collide_up
 jp c,moveLoop
 ld a,(temp)

 cp 16
 jr c,scrollMapUp

 ld (charY),a
 jp moveLoop

scrollMapUp:
 ld a,(mapY)
 or a
 jp z,finishMoveCharUp

 dec a
 ld (mapY),a
 ld a,(charY)
 add a,10
 ld (charY),a
 jp moveLoop

finishMoveCharUp:
 ld a,(charY)
 cp 2
 jp z,moveLoop
 dec a
 dec a
 ld (charY),a
 jp moveLoop

moveCharDown:
 ld a,3
 ld (charDir),a
 ld a,(charY)
 inc a
 inc a
 ld (y),a
 ld (temp),a
 call collide_down
 jp c,moveLoop
 ld a,(temp)

 cp 38
 jr nc,scrollMapDown

 ld (charY),a
 jp moveLoop

scrollMapDown:
 ld a,(mapHeight)
 sub 5
 ld b,a
 ld a,(mapY)
 cp b
 jp z,finishMoveCharDown

 inc a
 ld (mapY),a
 ld a,(charY)
 sub 10
 ld (charY),a
 jp moveLoop

finishMoveCharDown:
 ld a,(charY)
 cp 50
 jp z,moveLoop
 inc a
 inc a
 ld (charY),a
 jp moveLoop

adjustMap:
 ld hl,(mapStart)
 ld a,(mapY)
 ld b,a
 or a
 jr z,_dontAdjustMap

 ld a,(mapWidth)
 ld e,a
 ld d,0
_adjustMapStart:
 add hl,de
 djnz _adjustMapStart

_dontAdjustMap:
 ld a,(mapX)
 ld e,a
 ld d,0
 add hl,de
 ret

drawmap:
 ; adjust map start
 call adjustMap

 ld a,1
 ld (drawmapCounter),a

 ; map Adjusted properly to (mapX, mapY)

 ld de,plotSScreen+24		; area to be painted

 ld c,5				; number of rows to display
rowLoop:
 ld b,8			; number of columns to display
columnLoop:
 ld a,(hl)			; tile Identification
 or a
 jr z,skipBlankTile

 push bc
  push hl
   dec a			; 0 = blank space
   ld c,a
   ld b,0
   ld hl,0
   add hl,bc			; hl = a*24
   add hl,hl			;  since each sprite is 24 bytes long
	add hl,bc
   add hl,hl
   add hl,hl
	add hl,hl

   ld bc,tilemapSprites
   add hl,bc			; add offset to sprites

	; draw 12x12 sprite
	push de
    ld a,(drawmapCounter)
	 and 1
	 jr z,_drawOddTile

	 call drawEvenTile
    jr _tileDrawn

_drawOddTile:
    call drawOddTile

_tileDrawn:
	pop de
  pop hl
 pop bc

skipBlankTile:
 ; MOVE TO NEXT TILE LOCATION (DE) and NEXT MAP LOCATION (HL)

 ld a,(drawmapCounter)
 and 1
 jr nz,_skipEvenTile

 inc de
_skipEvenTile:
 ld a,(drawmapCounter)
 inc a
 ld (drawmapCounter),a
 inc de
 inc hl			; next byte = next tile ID
 djnz columnLoop

 ; tricky arithmetic is involved when moving from the right edge
 ;  and back to the left.

 push hl		; 11 rows = 132 bytes
  ld hl,132		; 12*11
  add hl,de
  ex de,hl
 pop hl

 push de
  ld a,(mapWidth)
  sub 8				; not 8, since we already incremented
  ld e,a
  ld d,0
  add hl,de
 pop de

 dec c
 jr nz,rowLoop		; do we need to loop again?
 ret


drawEvenTile:
    ld b,12
drawEvenTileLoop:
    push bc			
     ldi
	  ldi	  
	  push hl
	   ld hl,10
		add hl,de
		ex de,hl
	  pop hl
    pop bc
    djnz drawEvenTileLoop
	 ret

drawOddTile:
    ld b,12
drawOddTileLoop:
    push bc		
     ld b,(hl)
	  srl b
	  srl b
	  srl b
	  srl b
	  ld a,(de)
	  OR B
	  ld (de),a

	  inc de
     ld b,(hl)
	  sla b
	  sla b
	  sla b
	  sla b
	  inc hl
	  ld a,(hl)
	  srl a
	  srl a
	  srl a
	  srl a
     OR B
	  ld (de),a

	  inc hl
	  push hl
	   ld hl,11
		add hl,de
		ex de,hl
	  pop hl
    pop bc
    djnz drawOddTileLoop
	 ret


nightTime:
 ld hl,plotsscreen
 ld b,32
nightLoop:
 push bc

 ld b,12
nightLoop1a:
 ld a,(hl)
 or 10101010b
 ld (hl),a
 inc hl
 djnz nightLoop1a

 ld b,12
nightLoop1b:
 ld a,(hl)
 or 01010101b
 ld (hl),a
 inc hl
 djnz nightLoop1b

 pop bc
 djnz nightLoop
 ret

showCharacter:
 ; 0 = thief
 ; 1 = guard
 ld a,(charMovingSprite)
 ld b,a
 add a,a
 add a,b
 add a,a
 add a,a

 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 ld de,demoCharSprite
 add hl,de

 ; determine which sprite to draw
 ld a,(charDir)
 add a,a
 ld b,a

 ld a,(charTimer)
 srl a
 srl a
 srl a
 srl a
 and 1b
 add a,b

 ld b,a
 add a,a
 add a,b
 add a,a
 add a,a
 add a,a
 ld e,a
 ld d,0
 add hl,de 
  ld a,(charY)
 ld (y),a
 ld e,a
 ld a,(charX)
 ld (x),a
 call show12x12
 ret



 or a
 jr z,setNighttime

 xor a
 ld (night),a
 jp moveLoop

setNighttime:
 ld a,1
 ld (night),a
 jp moveLoop

debugMap:
 call dmapSub
 jp moveLoop

dmapSub:
 push hl
 push de
 ld hl,256*8
 ld (pencol),hl
 ld a,(x)
 B_CALL setxxop1
 ld a,5
 B_CALL dispop1a

 ld a,Lcomma
 B_CALL vputmap

 ld a,(y)
 B_CALL setxxop1
 ld a,5
 B_CALL dispop1a

 call getYourPosition
 ld a,(hl)
 B_CALL setxxop1
 ld a,3
 B_CALL dispop1a
 B_CALL GrBufCpy

 call adjustMap
 push hl
  xor a
  ld (currow),a
  ld (curcol),a
  B_CALL disphl
 pop hl
 push hl
  	call mapPosDE
  	ex de,hl
  push hl
   B_CALL disphl
  pop hl
  ex de,hl
 pop hl
 add hl,de

  B_CALL GetKey
 pop de
 pop hl
 ret

show12x12:
 push hl		; store Sprite Pointer
 ld d,0
 ld hl,0
 add hl,de
 add hl,de
 add hl,de
 add hl,hl
 add hl,hl		; de * 12
 
 push af
 srl a
 srl a
 srl a			; x/8
 ld e,a
 add hl,de
 ex de,hl
 ld hl,plotsscreen	; 8e29h on 83
 add hl,de		; hl = location we want to paint at
 pop af
 
 and 111b
 or a
 jr z,aligned_sprite0

 pop ix
 ld e,a

 ld c,12			; loop 'c' times, for vertical sprite size
spriteNAloop0:

 ld b,e			; 'e' - the remainder of a, determines the offset
 ld d,(ix+0)
 xor a
shlop0:
 srl d			; right piece
 rr a			; left piece
 djnz shlop0

 push af
 ld a,(hl)
 or d
 ld (hl),a		; load the 3 pieces of the sprite
 inc hl
 ld b,(hl)
 pop af
 or b
 ld (hl),a

 inc ix

 ld b,e			; 'e' - the remainder of a, determines the offset
 ld d,(ix+0)
 xor a
shlop00:
 srl d			; right piece
 rr a			; left piece
 djnz shlop00

 push af
 ld a,(hl)
 or d
 ld (hl),a		; load the 3 pieces of the sprite
 inc hl
 ld b,(hl)
 pop af
 or b
 ld (hl),a

 push de		; go to next line
  ld de,10
  add hl,de
 pop de

 inc ix

 dec c
 jr nz,spriteNAloop0
 ret 


aligned_sprite0:	; hl - pointer to buffer
 pop de			; de - pointer to sprite

 ld b,12			; loops = vertical size of sprite
alop0:
 ld a,(hl)
 ld a,(de)
 ld (hl),a
 inc hl
 inc de
 ex de,hl
 ld a,(de)
 and 1111b
 or (hl)
 ld (de),a
 ex de,hl

 ld (hl),a

 push de
  ld de,11
  add hl,de
 pop de
 inc de
 djnz alop0
 ret

